/*-----------------------------------------------------------------------*/
/*  (C) Copyright Institute of Astronomy ETHZ 8092 Zuerich Switzerland   */
/*-----------------------------------------------------------------------*/
/*  Programmname: unit1.cpp                                              */
/*                                                                       */
/*  Revision: V1.2     Date: 15.08.2008    Autor: Chr. Monstein          */
/*                                                                       */
/*  Purpose: Generator Frequenzprogramm fuer CALLISTO                    */
/*                                                                       */
/*  Compiler: BORLAND C++Builder 6                                       */
/*-----------------------------------------------------------------------*/

// Created by: Chr. Monstein 04.01.2007
// Updated by: Chr. Monstein 19.01.2007
// Updated by: A. James      06.08.2008     V1.21
// Updated by: A. James      12.01.2009     V2.0
// Updated by: Chr. Monstein 16.06.2009     V2.1
//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H

#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <FileCtrl.hpp>
#include <Mask.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Math.hpp>
//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// Von der IDE verwaltete Komponenten
    TDirectoryListBox *DirectoryListBox1;
    TFileListBox *FileListBox1;
    TDriveComboBox *DriveComboBox1;
    TLabel *Label1;
   TLabel *Label2;
   TLabel *Label5;
   TSaveDialog *SaveDialog1;
        TPanel *Panel1;
        TPanel *Panel2;
        TLabel *Label8;
        TLabel *Label9;
        TLabel *Label10;
        TLabel *Label11;
        TLabel *Label12;
        TLabel *Label13;
        TButton *BSavePrg;
        TPanel *Panel3;
        TEdit *Edit8;
        TLabel *Label21;
        TPanel *Panel4;
        TLabel *Label18;
        TScrollBar *ScrollBar1;
        TLabel *Label20;
        TScrollBar *ScrollBar2;
        TLabel *Label19;
        TLabel *Label17;
        TLabel *Label16;
        TPanel *Panel5;
        TRadioButton *RadioButton5;
        TRadioButton *RadioButton6;
        TLabel *Label22;
        TRadioButton *RadioButton1;
        TRadioButton *RadioButton2;
        TRadioButton *RadioButton3;
        TRadioButton *RadioButton4;
        TEdit *Edit1;
        TEdit *Edit2;
        TEdit *Edit3;
        TEdit *Edit4;
        TEdit *Edit5;
        TLabel *Label3;
        TPanel *Panel6;
        TButton *Button2;
        TButton *Button3;
        TLabel *Label4;
        TPanel *Panel7;
        TButton *RedrawButton;
        TButton *Bautoscale;
        TLabel *Label14;
        TLabel *Label15;
        TEdit *Edit6;
        TEdit *Edit7;
        TLabel *Label6;
        TButton *Button1;
        TButton *Button4;
        TButton *Button5;
        TButton *Button6;
        TCheckBox *CheckBoxFocus;
    void __fastcall FileListBox1DblClick(TObject *Sender);
    void __fastcall DriveComboBox1Change(TObject *Sender);
        void __fastcall Edit1Exit(TObject *Sender);
        void __fastcall Edit2Exit(TObject *Sender);
        void __fastcall Edit3Exit(TObject *Sender);
        void __fastcall RadioButton1Click(TObject *Sender);
        void __fastcall RadioButton2Click(TObject *Sender);
        void __fastcall RadioButton3Click(TObject *Sender);
        void __fastcall RadioButton4Click(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall FileListBox1Click(TObject *Sender);
        void __fastcall Edit6Change(TObject *Sender);
        void __fastcall Edit7Change(TObject *Sender);
        void __fastcall Button2Click(TObject *Sender);
        void __fastcall Button3Click(TObject *Sender);
        void __fastcall ScrollBar1Change(TObject *Sender);
        void __fastcall ScrollBar2Change(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall RedrawButtonClick(TObject *Sender);
        void __fastcall BSavePrgClick(TObject *Sender);
        void __fastcall BautoscaleClick(TObject *Sender);
        void __fastcall Button4Click(TObject *Sender);
        void __fastcall Edit8Change(TObject *Sender);
        void __fastcall FileListBox1KeyPress(TObject *Sender, char &Key);
        void __fastcall FileListBox1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall Button5Click(TObject *Sender);
        void __fastcall Button6Click(TObject *Sender);
private:	// Anwender-Deklarationen
public:		// Anwender-Deklarationen
    __fastcall TForm1(TComponent* Owner);
void __fastcall ReadConfig(void);
void __fastcall UpdateList(void);
void __fastcall PreviewFrqPrg(void);
void __fastcall ReadOverview(char *filename);
void __fastcall CopyOverview();
void __fastcall SelectChannels(int count);
void __fastcall SaveFrequencyProgram(int count);
};

//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif
