/*-----------------------------------------------------------------------*/
/*  (C) Copyright Institute of Astronomy ETHZ 8092 Zuerich Switzerland   */
/*-----------------------------------------------------------------------*/
/*  Programmname: unit4.cpp                                              */
/*                                                                       */
/*  Revision: V1.2     Date: 15.08.2008    Autor: Chr. Monstein          */
/*                                                                       */
/*  Purpose: Generator Frequenzprogramm fuer CALLISTO                    */
/*                                                                       */
/*  Compiler: BORLAND C++Builder 6                                       */
/*-----------------------------------------------------------------------*/

// Created by: Chr. Monstein 04.01.2007
// Updated by: Chr. Monstein 19.01.2007
// Updated by: A. James      06.08.2008     V1.21
// Updated by: A. James      12.01.2009     V2.0
// Updated by: Chr. Monstein 16.06.2009     V2.1
// Updated by: Chr. Monstein 17.08.2012     V2.2
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "Unit1.h"
#include "Unit4.h"
#include <stdio.h>
#include <fstream.h>
#include <math.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TForm4 *Form4;

extern long rows; // params
extern double *freq, *ampl, *fprog;
extern double range, rangemin;
extern int iFileDate;
extern bool frqprgsaved;
//---------------------------------------------------------------------------
__fastcall TForm4::TForm4(TComponent* Owner)
        : TForm(Owner)
{
   Form4->Width=Form1->Width;
   Form4->Height=Form1->Height; // Basisgroesse Plottfenster
   Form4->Top=0;//(Form1->Top)-(Form1->Height);
   Form4->Left=0;//Form1->Left;
}
//---------------------------------------------------------------------------
void __fastcall TForm4::FormResize(TObject *Sender)
{
   //Form4->Left=0;
   //Form4->Top=0;
   //Form4->Invalidate();
   Form4->PaintBox1Click(0);
}
//---------------------------------------------------------------------------
void Xaxis(int BBottom, int BTop, int BLeft, int BRight, int ALeft, int ARight, int ATop)
{
    char Label[240];
    int Nx=16; // number of ticks
    float dx; // Abstand der ticks in Pixels
    int w=Form4->PaintBox1->Canvas->TextWidth ("100000");
    int h;

    dx=(float)(BRight-BLeft)/(float)Nx; // Abstand der ticks in Pixels
    int i=0;
    int y1=BBottom; int y2=y1+5; int y3=y2+4;
    float x, xalt=-9999;

    Form4->PaintBox1->Canvas->Brush->Color=clWhite; // Schriftfarbe
    Form4->PaintBox1->Canvas->Pen->Color=clGray; // Liniefarbe

    do {
        x=(float)BLeft+(float)i*dx;
        Form4->PaintBox1->Canvas->MoveTo(x,y1);
        Form4->PaintBox1->Canvas->LineTo(x,y2);
        // sweepcalculation
        if (i == 0)
           sprintf(Label,"%7.2lf",freq[(int)(1)]);
        else
           sprintf(Label,"%7.2lf",freq[(int)(i*(rows-1)/Nx)]);

        if ((x-xalt)>(w+5))
        {
            xalt=x;
            Form4->PaintBox1->Canvas->LineTo(x,y3);
            Form4->PaintBox1->Canvas->TextOut(x-w/2,y3+2,Label);
        }
        i++;
    } while ((i<=Nx) ); // Nx

    char st[80];
    sprintf(Label,"Frequency [MHz]"); // y-label
    w=Form4->PaintBox1->Canvas->TextWidth(Label);
    h=Form4->PaintBox1->Canvas->TextHeight(Label);
    Form4->PaintBox1->Canvas->TextOut((BLeft+BRight)/2-w/2,y3+h,Label);
    Form4->PaintBox1->Canvas->Font->Size=9;
    sprintf(Label,"%s%s","Intensity of ",Form1->FileListBox1->FileName.c_str()); // title
    Form4->Caption=Label; // top titel
    sprintf(Label,"File->%s",ExtractFileName(Form1->FileListBox1->FileName));
    w=Form4->PaintBox1->Canvas->TextWidth(Label);
    Form4->PaintBox1->Canvas->TextOut((ALeft+ARight)/2-w/2+5,ATop+2,Label); // 2. titel
}
//---------------------------------------------------------------------------
void Yaxis(int BBottom, int BTop, int BLeft, int ALeft, int ATop, int BRight, int ARight)
{
    char Label[40];
    int Ny=10;  // 22number of zwischenrume
    int i, w, h, x1, x2;
    float dy=(float)(BBottom-BTop)/(float)Ny;  // digits
    float y, ys;
    i=0;
    x1=BLeft;
    x2=x1-5;
    do {
        y=(float)BBottom-(float)i*dy; // digits from bottom
        Form4->PaintBox1->Canvas->MoveTo(x1,y);
        Form4->PaintBox1->Canvas->LineTo(x2,y); // horizontal ticks
        Form4->PaintBox1->Canvas->Pen->Color=clBlack; // Linienfarbe
        ys=((float)i*(range-rangemin)/(float)Ny)+rangemin; // y-label
        //ys=((float)i*(range)/(float)Ny); // y-label
        sprintf(Label,"%4i",(int)(ys)); // y-label
        w=Form4->PaintBox1->Canvas->TextWidth(Label);
        h=Form4->PaintBox1->Canvas->TextHeight(Label);
        Form4->PaintBox1->Canvas->Brush->Color=clWhite; // Schriftfarbe
        Form4->PaintBox1->Canvas->TextOut(BLeft-6-w,y-h/2,Label);
        i++;
    } while (i<=Ny);
    sprintf(Label,"mV"); // y-label
    Form4->PaintBox1->Canvas->TextOut(ALeft+2,ATop+2,Label);
}
//---------------------------------------------------------------------------
//SECONDARY Y-AXIS:
//---------------------------------------------------------------------------
void Yaxis2(int BBottom, int BTop, int BLeft, int ALeft, int ATop, int BRight, int ARight)
{
    char Label[40];
    int Ny=10;  // 22number of zwischenrume
    int i, w, h, x1, x2;
    int nchannels;
    float dy=(float)(BBottom-BTop)/(float)Ny;  // digits
    float y, ys;
    i=0;
    x1=BRight;
    x2=x1+5;
    nchannels = atoi(Form1->Edit1->Text.c_str());
    do {
        y=(float)BBottom-(float)i*dy; // digits from bottom
        Form4->PaintBox1->Canvas->MoveTo(x1,y);
        Form4->PaintBox1->Canvas->LineTo(x2,y); // horizontal ticks
        Form4->PaintBox1->Canvas->Pen->Color=clBlack; // Linienfarbe
        ys=((float)i*(nchannels)/(float)Ny); // y-label
        //ys=((float)i*(range)/(float)Ny); // y-label
        sprintf(Label,"%4i",(int)(ys)); // y-label
        w=Form4->PaintBox1->Canvas->TextWidth(Label);
        h=Form4->PaintBox1->Canvas->TextHeight(Label);
        Form4->PaintBox1->Canvas->Brush->Color=clWhite; // Schriftfarbe
        Form4->PaintBox1->Canvas->TextOut(BRight-10+w,y-h/2,Label);
        i++;
    } while (i<=Ny);
    sprintf(Label,"Chan."); // y-label
    Form4->PaintBox1->Canvas->TextOut(ARight-40,ATop-2,Label);
}
//---------------------------------------------------------------------------

void __fastcall TForm4::PaintBox1Click(TObject *Sender)
{
    float x, xa, y;
    int yp, ya;

    Form4->PaintBox1->Width  = ClientWidth;
    Form4->PaintBox1->Height = ClientHeight;
    // Ausserer Rahmen (Bildflaeche)
    int ALeft=0, ATop=0, ARight=ClientWidth-15, ABottom=ClientHeight-15; //40
    TRect Rahmen = Rect(ALeft,ATop,ARight, ABottom); // ALeft, ATop,  ARight,  ABottom
    Form4->PaintBox1->Canvas->Brush->Color=clWhite;//clYellow;
    Form4->PaintBox1->Canvas->FillRect(Rahmen);

    // Innerer (Plott)Rahmen
    int BLeft=50, BTop=25, BRight=ARight-40, BBottom=ABottom-40; // 50
    TRect Plottarea = Rect(BLeft,BTop,BRight, BBottom); // ALeft, ATop,  ARight,  ABottom
    Form4->PaintBox1->Canvas->Brush->Color=clNavy;//clBlack;
    Form4->PaintBox1->Canvas->FillRect(Plottarea);

    if (!FileExists(Form1->FileListBox1->FileName)) return; // nothing to draw
    if (rows<1) return;  // don't draw if nothing to draw! (header only)
    Xaxis(BBottom, BTop, BLeft, BRight, ALeft, ARight, ATop); // x-ticks
    float vrange=(float)(BBottom-BTop);
    float hrange=(float)(BRight-BLeft);
    int row = 0;
    if (range<1)
        range=1;
    Form4->PaintBox1->Canvas->Pen->Color=clYellow; // Linienfarbe
    if (rows>0)
    {
      do { // graph
          x = BLeft+(float)row/(float)rows*hrange; // resized x-axis
          yp= ((ampl[row]-rangemin)/float(range-rangemin))*vrange; // y-axis pointer
          y = BBottom-(float)yp; // resized y-axis
          if ((y>=BTop) && (y<BBottom)) {
            Form4->PaintBox1->Canvas->MoveTo(x,BBottom);
            Form4->PaintBox1->Canvas->Pixels[x][y] = clRed;//clRed/Yelow;
            Form4->PaintBox1->Canvas->LineTo(x,y); // nur wegen Windows Vista!
          }
          row++;
      } while (row < rows);
    }
    //KURVE FREQUENZPROGRAM
    if (frqprgsaved)
    {
       int nchannels = atoi(Form1->Edit1->Text.c_str());
       int channel = 0;
       if (nchannels<1)
          nchannels=1;
       if (channel>=0)
       {
         do { // graph
             x = BLeft+((float)(fprog[channel]-45))/(float)(825)*hrange; // resized x-axis
             yp= ((channel+1)/float(nchannels))*vrange; // y-axis pointer
             y = BBottom-(float)yp; // resized y-axis
             if ((y>=BTop) && (y<BBottom)) {
             Form4->PaintBox1->Canvas->MoveTo(x,BBottom);
             Form4->PaintBox1->Canvas->Pixels[x][y] = clLime;
             }
             channel++;
            } while (channel < nchannels);
       }
    }
    //SCROLLBAR 1 MOVE
    if (Form1->ScrollBar1->Position!=Form1->ScrollBar1->Min && Form1->ScrollBar1->Position!=Form1->ScrollBar1->Max)
    {
      float pos1=Form1->ScrollBar1->Position;
      x = BLeft+(float)((pos1/10000)-45)/(float)(825)*hrange; // resized x-axis
      PaintBox1->Canvas->Pen->Style = psSolid;
      Form4->PaintBox1->Canvas->Pen->Width = 0; // strichstaerke
      Form4->PaintBox1->Canvas->Pen->Color=clRed;
      Form4->PaintBox1->Canvas->MoveTo(x,BTop);
      Form4->PaintBox1->Canvas->LineTo(x,BBottom);
    }
    //SCROLLBAR 2 MOVE
    if (Form1->ScrollBar2->Position!=Form1->ScrollBar2->Max && Form1->ScrollBar2->Position!=Form1->ScrollBar2->Min)
    {
      float pos2=Form1->ScrollBar2->Position;
      x = BLeft+(float)((pos2/10000)-45)/(float)(825)*hrange; // resized x-axis
      Form4->PaintBox1->Canvas->Pen->Color=clRed;
      Form4->PaintBox1->Canvas->MoveTo(x,BTop);
      Form4->PaintBox1->Canvas->LineTo(x,BBottom);
    }
    //
    Yaxis(BBottom, BTop, BLeft, ALeft, ATop, BRight, ARight); // y-ticks
    Yaxis2(BBottom, BTop, BLeft, ALeft, ATop, BRight, ARight); // y-ticks
    if (Form1->CheckBoxFocus->Checked==false) Form1->Show();
    //if (Form1->CheckBoxFocus->Checked==true) Form4->TopMost=true;

}
//---------------------------------------------------------------------------

void __fastcall TForm4::FormClick(TObject *Sender)
{
    //Form4->Show(); // show before plott
    Form4->PaintBox1Click(0);
}
//---------------------------------------------------------------------------
//Show coordinates in the title bar, when mouse cursor is within plotwindow
//---------------------------------------------------------------------------
void __fastcall TForm4::FormMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
   char st[80];
   char val_x[25];
   char val_y[25];
   int BLeft=50;
   int BTop=25;
   float BBottom=Form4->PaintBox1->Height-55;
   float BRight=Form4->PaintBox1->Width-55;
   float vrange=(float)(BBottom-BTop);
   float hrange=(float)(BRight-BLeft);
   float ymin = rangemin;
   float ymax = range;

   if ((ymax-(((Y-BTop-8)/vrange)*(ymax-ymin))) >= ymin && (ymax-(((Y-BTop-8)/vrange)*(ymax-ymin))) <= ymax)
       sprintf(val_y,"mV = %4.0f",ymax-(((Y-BTop-8)/vrange)*(ymax-ymin)));
   else
       sprintf(val_y,"");

   if ((((X-BLeft-8)*825/hrange)+45) >= 45 && (((X-BLeft-8)*825/hrange)+45) <= 870)
   {
       if (val_y[0] != 0)
          sprintf(val_x,"frequency = %6.1f MHz/",((X-BLeft-8)*825/hrange)+45);
       else
          sprintf(val_x,"frequency = %6.1f MHz",((X-BLeft-8)*825/hrange)+45);
   }
   else
   {
       sprintf(val_x,"");
   }

   if (val_x[0]|| val_y[0] != 0)
       sprintf(st,"Overview Spectrum Plot [%s%s]",val_x,val_y);
   else
       sprintf(st,"Overview Spectrum Plot",val_x,val_y);
   Form4->Caption = st;

}
//---------------------------------------------------------------------------


void __fastcall TForm4::FormDblClick(TObject *Sender)
{
    ShowMessage("Yellow=Overview Spectrum\nGreen=Generated Frequency Program\nRed=Excluded Range Selection\n");
}
//---------------------------------------------------------------------------

